package ru.dbotthepony.mc.otm.datagen.blocks

import net.minecraft.resources.ResourceLocation
import net.minecraft.world.level.block.Block
import net.minecraftforge.client.model.generators.BlockStateProvider
import net.minecraftforge.data.event.GatherDataEvent
import ru.dbotthepony.mc.otm.block.BatteryBankBlock
import ru.dbotthepony.mc.otm.block.RotatableMatteryBlock
import ru.dbotthepony.mc.otm.datagen.DataGen
import ru.dbotthepony.mc.otm.datagen.toYRotBlockstate
import ru.dbotthepony.mc.otm.registry.MBlocks

private fun nothingOrNumber(input: Int): String {
	if (input == 0)
		return ""

	return (input - 1).toString()
}

open class BatteryBankProvider(event: GatherDataEvent) : BlockStateProvider(event.generator, DataGen.MOD_ID, event.existingFileHelper) {
	protected var block = "battery_bank"
	protected var batteryPath = "block/battery/battery"
	protected var registry: Block = MBlocks.BATTERY_BANK

	override fun registerStatesAndModels() {
		with(getMultipartBuilder(registry)) {
			val battery_bank = models().getExistingFile(ResourceLocation("overdrive_that_matters:block/$block"))

			RotatableMatteryBlock.FACING.possibleValues.forEach {
				part().modelFile(battery_bank).rotationY(it.toYRotBlockstate()).addModel().condition(
					RotatableMatteryBlock.FACING, it)

				for (i in 0 .. 11) {
					part().modelFile(
						models().getExistingFile(ResourceLocation("overdrive_that_matters:$batteryPath$i"))
					).rotationY(it.toYRotBlockstate()).addModel()
						.condition(RotatableMatteryBlock.FACING, it)
						.condition(BatteryBankBlock.BATTERY_SLOTS_PROPS[i], true)
				}
			}
		}
	}
}

class MatterBankProvider(event: GatherDataEvent) : BatteryBankProvider(event) {
	init {
		block = "matter_capacitor_bank"
		batteryPath = "block/battery/matter_capacitor"
		registry = MBlocks.MATTER_CAPACITOR_BANK
	}
}
