package ru.dbotthepony.mc.otm.data

import com.mojang.serialization.Codec
import com.mojang.serialization.codecs.RecordCodecBuilder
import it.unimi.dsi.fastutil.objects.ObjectArrayList
import net.minecraft.world.item.ItemStack
import net.minecraft.world.level.storage.loot.LootContext
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition
import net.minecraftforge.common.loot.IGlobalLootModifier
import net.minecraftforge.common.loot.LootModifier
import ru.dbotthepony.mc.otm.core.ImmutableList

class LootTableBasicAppender(
	conditions: Array<out LootItemCondition>,
	items: List<ItemStack>
) : LootModifier(conditions) {
	private val items = ImmutableList(items.size) { items[it].copy() }

	override fun codec(): Codec<out IGlobalLootModifier> {
		return CODEC
	}

	override fun doApply(
		generatedLoot: ObjectArrayList<ItemStack>,
		context: LootContext
	): ObjectArrayList<ItemStack> {
		generatedLoot.addAll(items)
		return generatedLoot
	}

	companion object {
		val CODEC: Codec<LootTableBasicAppender> by lazy {
			RecordCodecBuilder.create {
				codecStart(it).and(ItemStackCodec.LIST.fieldOf("items").forGetter { it.items }).apply(it, ::LootTableBasicAppender)
			}
		}
	}
}
