package ru.dbotthepony.mc.otm.item

import net.minecraft.client.model.HumanoidModel
import net.minecraft.sounds.SoundEvent
import net.minecraft.sounds.SoundEvents
import net.minecraft.world.entity.Entity
import net.minecraft.world.entity.EquipmentSlot
import net.minecraft.world.entity.LivingEntity
import net.minecraft.world.item.ArmorItem
import net.minecraft.world.item.ArmorMaterial
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Rarity
import net.minecraft.world.item.crafting.Ingredient
import net.minecraftforge.client.extensions.common.IClientItemExtensions
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.client.model.TritaniumArmorModel
import ru.dbotthepony.mc.otm.registry.MItemTags
import java.util.function.Consumer

private object TritaniumArmorMaterial : ArmorMaterial {
	override fun getDurabilityForSlot(p_40410_: EquipmentSlot): Int {
		return when (p_40410_) {
			EquipmentSlot.MAINHAND -> throw IllegalArgumentException("yo dude what the fuck")
			EquipmentSlot.OFFHAND -> throw IllegalArgumentException("yo dude what the fuck")
			EquipmentSlot.FEET -> 470
			EquipmentSlot.LEGS -> 540
			EquipmentSlot.CHEST -> 820
			EquipmentSlot.HEAD -> 520
		}
	}

	override fun getDefenseForSlot(p_40411_: EquipmentSlot): Int {
		return when (p_40411_) {
			EquipmentSlot.MAINHAND -> throw IllegalArgumentException("yo dude what the fuck")
			EquipmentSlot.OFFHAND -> throw IllegalArgumentException("yo dude what the fuck")
			EquipmentSlot.FEET -> 4
			EquipmentSlot.LEGS -> 7
			EquipmentSlot.CHEST -> 12
			EquipmentSlot.HEAD -> 5
		}
	}

	override fun getEnchantmentValue() = 9
	override fun getEquipSound(): SoundEvent = SoundEvents.ARMOR_EQUIP_IRON
	override fun getRepairIngredient(): Ingredient = Ingredient.of(MItemTags.TRITANIUM_INGOTS)

	const val ID = "${OverdriveThatMatters.MOD_ID}:tritanium_armor"

	override fun getName(): String = ID
	override fun getToughness() = 2.6f
	override fun getKnockbackResistance() = 0.2f
}

private object TritaniumArmorRenderProperties : IClientItemExtensions {
	override fun getHumanoidArmorModel(
		entityLiving: LivingEntity,
		itemStack: ItemStack,
		armorSlot: EquipmentSlot,
		_default: HumanoidModel<*>
	): HumanoidModel<*> {
		if (armorSlot === EquipmentSlot.LEGS) {
			return TritaniumArmorModel.getModelLegs()
		}

		return TritaniumArmorModel.getModel()
	}
}

class ItemTritaniumArmor(slot: EquipmentSlot) : ArmorItem(TritaniumArmorMaterial, slot, Properties().stacksTo(1).rarity(Rarity.RARE).tab(OverdriveThatMatters.INSTANCE.CREATIVE_TAB)) {
	override fun initializeClient(consumer: Consumer<IClientItemExtensions>) {
		super.initializeClient(consumer)
		consumer.accept(TritaniumArmorRenderProperties)
	}

	override fun getArmorTexture(stack: ItemStack?, entity: Entity?, slot: EquipmentSlot?, type: String?): String {
		return TEXTURE_LOCATION
	}

	companion object {
		const val TEXTURE_LOCATION = "${OverdriveThatMatters.MOD_ID}:textures/models/armor/tritanium_armor.png"
	}
}
